package lc.esp.cli.sdk;

import lc.esp.sdk.ESPMessage;
import lc.mecha.json.JSONArray;
import lc.mecha.json.JSONObject;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class CLIRequest {
    public static final String KEY_CMD = "cmd";
    private final ArrayList<String> cmd = new ArrayList<>();

    public CLIRequest(List<String> cmd) {
        this.cmd.addAll(cmd);
    }

    public CLIRequest(ESPMessage msg) {
        JSONArray arr = msg.getPayload().getJSONArray(KEY_CMD);
        for (int i = 0; i < arr.length(); i++) {
            cmd.add(arr.getString(i));
        }
    }

    public ESPMessage toMessage() {
        JSONObject jo = new JSONObject();
        JSONArray arr = new JSONArray();
        for (String c : cmd) {
            arr.put(c);
        }
        jo.put(KEY_CMD, arr);
        return new ESPMessage(jo);
    }

    @Override
    public String toString() {
        return "CLIRequest{" +
                "cmd='" + cmd + '\'' +
                '}';
    }

    public List<String> getCmd() {
        return Collections.unmodifiableList(cmd);
    }
}
