package lc.esp.cli.sdk;

import lc.esp.sdk.ESPMessage;
import lc.mecha.json.JSONObject;

public class CLIResponse {
    public static final String KEY_STDOUT = "out";
    public static final String KEY_STDERR = "err";
    private final String err;
    private final String out;

    public CLIResponse(String stdout, String stderr) {
        this.out = stdout;
        this.err = stderr;
    }

    public CLIResponse(ESPMessage msg) {
        JSONObject obj = msg.getPayload();
        out = obj.optString(KEY_STDOUT);
        err = obj.optString(KEY_STDERR);
    }

    public ESPMessage toMessage() {
        JSONObject jo = new JSONObject();
        if (out != null) jo.put(KEY_STDOUT, out);
        if (err != null) jo.put(KEY_STDERR, err);
        return new ESPMessage(jo);
    }

    public String getErr() {
        return err;
    }

    public String getOut() {
        return out;
    }

    @Override
    public String toString() {
        return "CLIResponse{" +
                "err='" + err + '\'' +
                ", out='" + out + '\'' +
                '}';
    }
}
