package lc.evelyn.svc;

import lc.esp.cli.sdk.CLIService;
import lc.esp.sdk.ESPAddress;
import lc.esp.sdk.ESPClient;
import lc.mecha.calc.CalcEngine;
import lc.mecha.cli.cmd.BasicCommandProcessor;
import lc.mecha.cli.cmd.CommandHandler;
import lc.mecha.cli.line.BasicLineHandler;

/**
 * This class implements Evelyn's CLI.
 *
 * @author Alex Leigh
 * @since 2.0
 */
public class EvelynCommands extends CLIService {
    private CalcEngine calcEngine = new CalcEngine();

    public EvelynCommands(ESPClient client, ESPAddress address) {
        super(client, address);
        setupFrame();
    }

    public EvelynCommands(ESPAddress address) throws Exception {
        super(address);
        setupFrame();
    }

    public EvelynCommands(String address) throws Exception {
        super(address);
        setupFrame();
    }

    private void setupFrame() {
        BasicCommandProcessor bcp = super.getBcp();
        bcp.getHandlers().putCommand("HELLO", new CommandHandler() {
            @Override
            public void handle(BasicLineHandler lineHandler, String[] cmd) throws Exception {
                lineHandler.write("Hello!", false);
            }
        });

        bcp.getHandlers().putCommand("CALC", new CommandHandler() {
            @Override
            public void handle(BasicLineHandler lineHandler, String[] cmd) throws Exception {
                String result = calcEngine.calc(cmd[1]);
                lineHandler.write(result, false);
            }
        });
    }
}