package lc.hello.service;

import lc.esp.sdk.ESPMessage;
import lc.esp.sdk.service.ESPService;
import lc.mecha.json.JSONObject;

/**
 * The hello service greets a caller. This service is really only useful for dev/test and as an illustrative example
 * of the request/response cycle in ESP18.
 *
 * @author Alex Leigh
 * @since mk18 (GIPSY DANGER)
 */
public class HelloService extends ESPService {
    public HelloService() throws Exception {
        super("queue://lc.dev.example.hello.cmd");
    }

    public static void main(String[] args) throws Exception {
        new HelloService().run();
    }

    @Override
    public ESPMessage handle(ESPMessage request) {
        String theirName = request.getPayload().getString("name");
        JSONObject replyJson = new JSONObject();
        replyJson.put("msg", "Hello, " + theirName);
        return new ESPMessage(replyJson);
    }
}