package lc.ircbot.svc;

import lc.esp.cli.sdk.CLIClient;
import lc.esp.cli.sdk.CLIResponse;
import lc.esp.sdk.ESPAddress;
import lc.esp.sdk.ESPClient;
import org.pircbotx.hooks.ListenerAdapter;
import org.pircbotx.hooks.types.GenericMessageEvent;

import java.util.Arrays;

/**
 * This class implements a {@link ListenerAdapter} which listens for messages sent to the bot, relaying them
 * to ESP.
 *
 * @author Alex Leigh
 * @since 1.2
 */
public class BotListener extends ListenerAdapter {
    private final CLIClient cli;

    public BotListener() throws Exception {
        cli = new CLIClient(new ESPClient(), new ESPAddress("queue://lc.global.loa.evelyn.cmd"));
        new Thread(cli).start();
    }

    @Override
    public void onGenericMessage(GenericMessageEvent event) {
        String baseMsg = event.getMessage().replaceAll("\\P{Print}", "");

        try {
            if (baseMsg.startsWith("evelyn:")) {
                String msg = baseMsg.substring("evelyn:".length()).trim();
                String[] msgArr = msg.split(" ");
                // FIXME: We must have a timeout here or we will hang/leak this thread
                CLIResponse res = cli.exec(Arrays.asList(msgArr));
                event.respond(res.getOut());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
