package lc.ircbot.svc;

import lc.mecha.log.MechaLogger;
import lc.mecha.log.MechaLoggerFactory;
import lc.mecha.util.BasicallyDangerous;
import org.pircbotx.Configuration;
import org.pircbotx.PircBotX;

/**
 * Evelyn is a digital assist in the guise of an IRC bot. It is programmed to inhabit the #leighco
 * channel on the LEIGH&CO IRC network.
 *
 * @author Alex Leigh
 * @since 1.0
 */

//TODO This should really be a generic bot

public class IRCBotService extends BasicallyDangerous {
    private static final MechaLogger logger = MechaLoggerFactory.getLogger(IRCBotService.class);
    private PircBotX bot;
    private final String name = "evelyn_";

    public static void main(String[] args) throws Exception {
        new IRCBotService().run();
    }

    public IRCBotService() throws Exception {
        // TODO: Configure this from ZERO
        Configuration configuration = new Configuration.Builder()
                .setName(name)
                .addServer("irc0.leigh-co.com")
                .addAutoJoinChannel("#leighco")
                .addListener(new BotListener())
                .setRealName(name)
                .setLogin(name)
                .setWebIrcUsername(name)
                .buildConfiguration();

        bot = new PircBotX(configuration);
    }

    @Override
    public void runDangerously() throws Exception {
        bot.startBot();
    }
}
